use barrel::backend::SqlGenerator;
pub use diesel::connection::Connection;

pub trait Connectable {
    type Connection: Connection;
    type SqlGenerator: SqlGenerator;
    fn connect(&self) -> diesel::ConnectionResult<Self::Connection>;
}

pub struct Sqlite {
    pub db_file: &'static str,
}

impl Connectable for Sqlite {
    type Connection = diesel::sqlite::SqliteConnection;
    type SqlGenerator = barrel::backend::Sqlite;

    fn connect(&self) -> diesel::ConnectionResult<Self::Connection> {
        Self::Connection::establish(self.db_file)
    }
}
